--- link-summarizer.php	2007-12-12 10:54:44.000000000 +0700
+++ link-summarizer.php-	2007-12-12 11:24:12.000000000 +0700
@@ -226,7 +226,7 @@
 				if (!array_key_exists($link_url, $linkarray)) {
 					$linkarray = array_merge($linkarray, array($link_url => 1));
 					if ($optionarray['lnsum_urlshow']!=0) {
-						$link_summary .= "<li><a".$matches[1][$i]."href=\"".$matches[2][$i]."\"".$matches[3][$i].">".$matches[2][$i]."</a></li>";
+						$link_summary .= "<li><a".$matches[1][$i]."href=\"".$matches[2][$i]."\"".$matches[3][$i].">".lnsum_limit_link_output($matches[2][$i])."</a></li>";
 					}
 					else
 					{
@@ -264,6 +264,17 @@
 	return $input;
 }
 
+function lnsum_limit_link_output($input) {
+	$link_url_junk = $input;
+	$lnsum_url_limit = 70;
+        $lnsum_url_range = $lnsum_url_limit / 2;
+        if (strlen($link_url_junk) >= $lnsum_url_limit) {
+		$link_url_junk = substr($link_url_junk,0,$lnsum_url_range) . "..." . substr($link_url_junk,-$lnsum_url_range,$lnsum_url_range);
+	}
+	return $link_url_junk;
+}
+
+
 function link_summarizer_options_subpanel() {
 
 	if ( (isset($_POST['delete'])) && (!isset($_POST['confirmed'])) ) {
